<%@ Assembly Name="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Assembly Name="Microsoft.Office.Server, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Assembly Name="Microsoft.Office.Server.UserProfiles, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Page Language="C#" Debug="true" MasterPageFile="~/_layouts/application.master" Inherits="Microsoft.SharePoint.WebControls.LayoutsPageBase" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<%@ Import Namespace="Microsoft.SharePoint.Utilities" %>
<%@ Import Namespace="System.Collections" %>
<%@ Import Namespace="System.Collections.Generic" %>
<%@ Import Namespace="Microsoft.Office.Server.UserProfiles" %>
<%@ Import Namespace="Microsoft.Office.Server" %>

<script runat="server">

  protected override void OnLoad(EventArgs e)
  {
    try
    {
      string lit = "";
      int maxProfiles = 99999;
      string nbrProfiles = HttpContext.Current.Request.QueryString["nbrprofiles"];
      if (!string.IsNullOrEmpty(nbrProfiles)) maxProfiles = Int32.Parse(nbrProfiles);
      lit += "<li>max. nbr. profiles=" + maxProfiles;
      lit += "<li>Start:" + DateTime.Now.ToLongTimeString();

      SPServiceContext context = SPServiceContext.Current;
      UserProfileManager upman = null;
      HttpContext saveContext = null;
      SPSecurity.RunWithElevatedPrivileges(delegate()
      {
        try
        {
          saveContext = HttpContext.Current;
          HttpContext.Current = null;

          string cacheKey = "AESDGlobalCache";
          if (saveContext.Cache[cacheKey] == null)
            lit += "<li>Cache is empty";
          else
            lit += "<li>Cache is already populated";
            
          upman = new UserProfileManager(context);
          IEnumerator IUserProfiles = upman.GetEnumerator();
          IUserProfiles.Reset();
          int upcount = 0;
          ArrayList alUserProfiles;
          alUserProfiles = new ArrayList();
          
          while (IUserProfiles.MoveNext())
          {
            alUserProfiles.Add(((UserProfile)IUserProfiles.Current));
            upcount++;
            if (upcount >= maxProfiles) break;
          }
          
          lit += "<li>User Profiles found:" + upcount;

          int cacheDuration = 1440;
          saveContext.Cache.Insert(cacheKey, alUserProfiles, null, DateTime.Now.AddMinutes(cacheDuration), TimeSpan.Zero);
          lit += "<li>UP added to cache using " + cacheKey;
          lit += "<li>Stop:" + DateTime.Now.ToLongTimeString();
          HttpContext.Current = saveContext;
        }
        catch (Exception ex)
        {
          if ((HttpContext.Current == null) && (saveContext != null)) HttpContext.Current = saveContext;
          lit += "<li>User Profile Error: " + ex.Message;
          lit += "<br>User Profile Error: " + ex.StackTrace;
        }
      });
      StatusLabel.Text += lit; 
    }
    catch (Exception err)
    {
      StatusLabel.Text += "Error: " + err.Message;
    }
  }
  
</script>

<asp:Content ID="Content1" ContentPlaceholderID="PlaceHolderAdditionalPageHead" runat="server">
</asp:Content>

<asp:Content ID="Main" ContentPlaceHolderID="PlaceHolderMain" runat="server">
  <div style="padding:10px">
      <asp:Literal ID="StatusLabel" runat="server"></asp:Literal>
  </div>
</asp:Content>
<asp:Content ID="PageTitle" ContentPlaceHolderID="PlaceHolderPageTitle" runat="server">Load User Profile Cache</asp:Content>
<asp:Content ID="PageTitleInTitleArea" runat="server" ContentPlaceHolderID="PlaceHolderPageTitleInTitleArea">Load User Profile Cache</asp:Content>
